package com.ustadmobile.core.db.dao;

import java.lang.System;

@com.ustadmobile.door.annotation.Repository()
@androidx.room.Dao()
@kotlin.Metadata(mv = {1, 6, 0}, k = 1, d1 = {"\u0000.\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0010 \n\u0000\n\u0002\u0010\b\n\u0002\b\u0003\n\u0002\u0010\t\n\u0002\b\u0004\n\u0002\u0010\u0002\n\u0002\b\u0007\b\'\u0018\u00002\b\u0012\u0004\u0012\u00020\u00020\u0001:\u0002\u0015\u0016B\u0005\u00a2\u0006\u0002\u0010\u0003J%\u0010\u0004\u001a\b\u0012\u0004\u0012\u00020\u00020\u00052\f\u0010\u0006\u001a\b\u0012\u0004\u0012\u00020\u00070\u0005H\u00a7@\u00f8\u0001\u0000\u00a2\u0006\u0002\u0010\bJ\u001a\u0010\t\u001a\u0004\u0018\u00010\u00022\u0006\u0010\n\u001a\u00020\u000b2\u0006\u0010\f\u001a\u00020\u000bH\'J\u001a\u0010\r\u001a\u0004\u0018\u00010\u00022\u0006\u0010\u000e\u001a\u00020\u000b2\u0006\u0010\f\u001a\u00020\u000bH\'J\u0011\u0010\u000f\u001a\u00020\u0010H\u00a7@\u00f8\u0001\u0000\u00a2\u0006\u0002\u0010\u0011J\u001b\u0010\u0012\u001a\u00020\u00102\b\b\u0001\u0010\u0013\u001a\u00020\u000bH\u00a7@\u00f8\u0001\u0000\u00a2\u0006\u0002\u0010\u0014\u0082\u0002\u0004\n\u0002\b\u0019\u00a8\u0006\u0017"}, d2 = {"Lcom/ustadmobile/core/db/dao/XLangMapEntryDao;", "Lcom/ustadmobile/core/db/dao/BaseDao;", "Lcom/ustadmobile/lib/db/entities/XLangMapEntry;", "()V", "getValuesWithListOfId", "", "ids", "", "(Ljava/util/List;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "getXLangMapFromObject", "objectUid", "", "langMapUid", "getXLangMapFromVerb", "verbUid", "replicateOnChange", "", "(Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "replicateOnNewNode", "newNodeId", "(JLkotlin/coroutines/Continuation;)Ljava/lang/Object;", "Verb", "XObject", "lib-database-android_release"})
public abstract class XLangMapEntryDao implements com.ustadmobile.core.db.dao.BaseDao<com.ustadmobile.lib.db.entities.XLangMapEntry> {
    
    public XLangMapEntryDao() {
        super();
    }
    
    @org.jetbrains.annotations.Nullable()
    @com.ustadmobile.door.annotation.ReplicationRunOnNewNode()
    @androidx.room.Query(value = "\n         REPLACE INTO XLangMapEntryReplicate(xlmePk, xlmeDestination)\n          SELECT DISTINCT XLangMapEntry.statementLangMapUid AS xlmePk,\n                 :newNodeId AS xlmeDestination\n            FROM XLangMapEntry\n                 JOIN UserSession ON UserSession.usClientNodeId = :newNodeId\n             --notpsql      \n             WHERE XLangMapEntry.statementLangMapLct != COALESCE(\n                 (SELECT xlmeVersionId\n                    FROM XLangMapEntryReplicate\n                   WHERE xlmePk = XLangMapEntry.statementLangMapUid\n                     AND xlmeDestination = UserSession.usClientNodeId), 0)\n             --endnotpsql         \n          /*psql ON CONFLICT(xlmePk, xlmeDestination) DO UPDATE\n                 SET xlmePending = (SELECT XLangMapEntry.statementLangMapLct\n                                      FROM XLangmapEntry\n                                     WHERE XLangmapEntry.statementLangMapUid = EXCLUDED.xlmePk)\n                                        != XLangMapEntryReplicate.xlmeVersionId\n          */       \n     ")
    @com.ustadmobile.door.annotation.ReplicationCheckPendingNotificationsFor(value = {com.ustadmobile.lib.db.entities.XLangMapEntry.class})
    public abstract java.lang.Object replicateOnNewNode(@com.ustadmobile.door.annotation.NewNodeIdParam()
    long newNodeId, @org.jetbrains.annotations.NotNull()
    kotlin.coroutines.Continuation<? super kotlin.Unit> continuation);
    
    @org.jetbrains.annotations.Nullable()
    @androidx.room.Query(value = "\n REPLACE INTO XLangMapEntryReplicate(xlmePk, xlmeDestination)\n  SELECT DISTINCT XLangMapEntry.statementLangMapUid AS xlmeUid,\n         UserSession.usClientNodeId AS xlmeDestination\n    FROM ChangeLog\n         JOIN XLangMapEntry\n             ON ChangeLog.chTableId = 74\n                AND ChangeLog.chEntityPk = XLangMapEntry.statementLangMapUid\n         JOIN UserSession ON UserSession.usStatus = 1\n   WHERE UserSession.usClientNodeId != (\n         SELECT nodeClientId \n           FROM SyncNode\n          LIMIT 1)\n     AND XLangMapEntry.statementLangMapLct != COALESCE(\n         (SELECT xlmeVersionId\n            FROM XLangMapEntryReplicate\n           WHERE xlmePk = XLangMapEntry.statementLangMapUid\n             AND xlmeDestination = UserSession.usClientNodeId), 0)\n /*psql ON CONFLICT(xlmePk, xlmeDestination) DO UPDATE\n     SET xlmePending = true\n  */               \n    ")
    @com.ustadmobile.door.annotation.ReplicationCheckPendingNotificationsFor(value = {com.ustadmobile.lib.db.entities.XLangMapEntry.class})
    @com.ustadmobile.door.annotation.ReplicationRunOnChange(value = {com.ustadmobile.lib.db.entities.XLangMapEntry.class})
    public abstract java.lang.Object replicateOnChange(@org.jetbrains.annotations.NotNull()
    kotlin.coroutines.Continuation<? super kotlin.Unit> continuation);
    
    @org.jetbrains.annotations.Nullable()
    @androidx.room.Query(value = "SELECT * FROM XLangMapEntry WHERE objectLangMapUid IN (:ids)")
    public abstract java.lang.Object getValuesWithListOfId(@org.jetbrains.annotations.NotNull()
    java.util.List<java.lang.Integer> ids, @org.jetbrains.annotations.NotNull()
    kotlin.coroutines.Continuation<? super java.util.List<com.ustadmobile.lib.db.entities.XLangMapEntry>> continuation);
    
    @org.jetbrains.annotations.Nullable()
    @androidx.room.Query(value = "SELECT * FROM XLangMapEntry WHERE \n            verbLangMapUid = :verbUid AND languageLangMapUid = :langMapUid LIMIT 1")
    public abstract com.ustadmobile.lib.db.entities.XLangMapEntry getXLangMapFromVerb(long verbUid, long langMapUid);
    
    @org.jetbrains.annotations.Nullable()
    @androidx.room.Query(value = "SELECT * FROM XLangMapEntry WHERE \n            objectLangMapUid = :objectUid AND languageLangMapUid = :langMapUid LIMIT 1")
    public abstract com.ustadmobile.lib.db.entities.XLangMapEntry getXLangMapFromObject(long objectUid, long langMapUid);
    
    @kotlin.Metadata(mv = {1, 6, 0}, k = 1, d1 = {"\u0000(\n\u0002\u0018\u0002\n\u0002\u0010\u0000\n\u0000\n\u0002\u0010\t\n\u0000\n\u0002\u0010\u000e\n\u0002\b\r\n\u0002\u0010\u000b\n\u0002\b\u0002\n\u0002\u0010\b\n\u0002\b\u0002\b\u0087\b\u0018\u00002\u00020\u0001B\u0019\u0012\b\b\u0002\u0010\u0002\u001a\u00020\u0003\u0012\b\b\u0002\u0010\u0004\u001a\u00020\u0005\u00a2\u0006\u0002\u0010\u0006J\t\u0010\u000f\u001a\u00020\u0003H\u00c6\u0003J\t\u0010\u0010\u001a\u00020\u0005H\u00c6\u0003J\u001d\u0010\u0011\u001a\u00020\u00002\b\b\u0002\u0010\u0002\u001a\u00020\u00032\b\b\u0002\u0010\u0004\u001a\u00020\u0005H\u00c6\u0001J\u0013\u0010\u0012\u001a\u00020\u00132\b\u0010\u0014\u001a\u0004\u0018\u00010\u0001H\u00d6\u0003J\t\u0010\u0015\u001a\u00020\u0016H\u00d6\u0001J\b\u0010\u0017\u001a\u00020\u0005H\u0016R\u001a\u0010\u0004\u001a\u00020\u0005X\u0086\u000e\u00a2\u0006\u000e\n\u0000\u001a\u0004\b\u0007\u0010\b\"\u0004\b\t\u0010\nR\u001a\u0010\u0002\u001a\u00020\u0003X\u0086\u000e\u00a2\u0006\u000e\n\u0000\u001a\u0004\b\u000b\u0010\f\"\u0004\b\r\u0010\u000e\u00a8\u0006\u0018"}, d2 = {"Lcom/ustadmobile/core/db/dao/XLangMapEntryDao$Verb;", "", "verbLangMapUid", "", "valueLangMap", "", "(JLjava/lang/String;)V", "getValueLangMap", "()Ljava/lang/String;", "setValueLangMap", "(Ljava/lang/String;)V", "getVerbLangMapUid", "()J", "setVerbLangMapUid", "(J)V", "component1", "component2", "copy", "equals", "", "other", "hashCode", "", "toString", "lib-database-android_release"})
    @kotlinx.serialization.Serializable()
    public static final class Verb {
        private long verbLangMapUid;
        @org.jetbrains.annotations.NotNull()
        private java.lang.String valueLangMap;
        
        @org.jetbrains.annotations.NotNull()
        public final com.ustadmobile.core.db.dao.XLangMapEntryDao.Verb copy(long verbLangMapUid, @org.jetbrains.annotations.NotNull()
        java.lang.String valueLangMap) {
            return null;
        }
        
        @java.lang.Override()
        public boolean equals(@org.jetbrains.annotations.Nullable()
        java.lang.Object other) {
            return false;
        }
        
        @java.lang.Override()
        public int hashCode() {
            return 0;
        }
        
        public Verb() {
            super();
        }
        
        public Verb(long verbLangMapUid, @org.jetbrains.annotations.NotNull()
        java.lang.String valueLangMap) {
            super();
        }
        
        public final long component1() {
            return 0L;
        }
        
        public final long getVerbLangMapUid() {
            return 0L;
        }
        
        public final void setVerbLangMapUid(long p0) {
        }
        
        @org.jetbrains.annotations.NotNull()
        public final java.lang.String component2() {
            return null;
        }
        
        @org.jetbrains.annotations.NotNull()
        public final java.lang.String getValueLangMap() {
            return null;
        }
        
        public final void setValueLangMap(@org.jetbrains.annotations.NotNull()
        java.lang.String p0) {
        }
        
        @org.jetbrains.annotations.NotNull()
        @java.lang.Override()
        public java.lang.String toString() {
            return null;
        }
    }
    
    @kotlin.Metadata(mv = {1, 6, 0}, k = 1, d1 = {"\u0000(\n\u0002\u0018\u0002\n\u0002\u0010\u0000\n\u0000\n\u0002\u0010\t\n\u0000\n\u0002\u0010\u000e\n\u0002\b\r\n\u0002\u0010\u000b\n\u0002\b\u0002\n\u0002\u0010\b\n\u0002\b\u0002\b\u0087\b\u0018\u00002\u00020\u0001B\u0019\u0012\b\b\u0002\u0010\u0002\u001a\u00020\u0003\u0012\b\b\u0002\u0010\u0004\u001a\u00020\u0005\u00a2\u0006\u0002\u0010\u0006J\t\u0010\u000f\u001a\u00020\u0003H\u00c6\u0003J\t\u0010\u0010\u001a\u00020\u0005H\u00c6\u0003J\u001d\u0010\u0011\u001a\u00020\u00002\b\b\u0002\u0010\u0002\u001a\u00020\u00032\b\b\u0002\u0010\u0004\u001a\u00020\u0005H\u00c6\u0001J\u0013\u0010\u0012\u001a\u00020\u00132\b\u0010\u0014\u001a\u0004\u0018\u00010\u0001H\u00d6\u0003J\t\u0010\u0015\u001a\u00020\u0016H\u00d6\u0001J\b\u0010\u0017\u001a\u00020\u0005H\u0016R\u001a\u0010\u0002\u001a\u00020\u0003X\u0086\u000e\u00a2\u0006\u000e\n\u0000\u001a\u0004\b\u0007\u0010\b\"\u0004\b\t\u0010\nR\u001a\u0010\u0004\u001a\u00020\u0005X\u0086\u000e\u00a2\u0006\u000e\n\u0000\u001a\u0004\b\u000b\u0010\f\"\u0004\b\r\u0010\u000e\u00a8\u0006\u0018"}, d2 = {"Lcom/ustadmobile/core/db/dao/XLangMapEntryDao$XObject;", "", "objectLangMapUid", "", "valueLangMap", "", "(JLjava/lang/String;)V", "getObjectLangMapUid", "()J", "setObjectLangMapUid", "(J)V", "getValueLangMap", "()Ljava/lang/String;", "setValueLangMap", "(Ljava/lang/String;)V", "component1", "component2", "copy", "equals", "", "other", "hashCode", "", "toString", "lib-database-android_release"})
    @kotlinx.serialization.Serializable()
    public static final class XObject {
        private long objectLangMapUid;
        @org.jetbrains.annotations.NotNull()
        private java.lang.String valueLangMap;
        
        @org.jetbrains.annotations.NotNull()
        public final com.ustadmobile.core.db.dao.XLangMapEntryDao.XObject copy(long objectLangMapUid, @org.jetbrains.annotations.NotNull()
        java.lang.String valueLangMap) {
            return null;
        }
        
        @java.lang.Override()
        public boolean equals(@org.jetbrains.annotations.Nullable()
        java.lang.Object other) {
            return false;
        }
        
        @java.lang.Override()
        public int hashCode() {
            return 0;
        }
        
        public XObject() {
            super();
        }
        
        public XObject(long objectLangMapUid, @org.jetbrains.annotations.NotNull()
        java.lang.String valueLangMap) {
            super();
        }
        
        public final long component1() {
            return 0L;
        }
        
        public final long getObjectLangMapUid() {
            return 0L;
        }
        
        public final void setObjectLangMapUid(long p0) {
        }
        
        @org.jetbrains.annotations.NotNull()
        public final java.lang.String component2() {
            return null;
        }
        
        @org.jetbrains.annotations.NotNull()
        public final java.lang.String getValueLangMap() {
            return null;
        }
        
        public final void setValueLangMap(@org.jetbrains.annotations.NotNull()
        java.lang.String p0) {
        }
        
        @org.jetbrains.annotations.NotNull()
        @java.lang.Override()
        public java.lang.String toString() {
            return null;
        }
    }
}